#!/bin/bash
# gjuhasz 20181115
# Brightness control slider for desktop 'external' monitors - with inspiration from johnywhy, and many thanks to Fredx181
#
if [[ -d /sys/class/backlight/intel_backlight ]] ; then
	MAXBR=`cat /sys/class/backlight/intel_backlight/max_brightness`
	AVGBR=$(awk "BEGIN {printf \"%.0f\n\", $MAXBR/3}")
	MINBR=$(awk "BEGIN {printf \"%.0f\n\", $MAXBR/50+4}") #because different intel card types have maxbr from 50 to 1500 
	sync
	if [ -f /tmp/BrNew.txt ]; then
		XR=`cat /tmp/BrNew.txt`
	else
		XR=$AVGBR
		echo $XR >/tmp/BrNew.txt
	fi
	echo $XR > /sys/class/backlight/intel_backlight/brightness
	sync
	BrCur=`awk "BEGIN {print $XR}"` # calculate, so e.g. 0.5 gets 50
	yad --undecorated --on-top --geometry=200x70-30-30 --text=" INTEL   BRIGHTNESS   CONTROL " --scale --value $BrCur --print-partial --min-value $MINBR --max-value $MAXBR --button="Done":1 | while read BrNew; do
	cd /sys/class/backlight/intel_backlight
	echo $BrNew > brightness
	sync
	cd ~
	echo $BrNew >/tmp/BrNew.txt
	done 
else
	# detect monitor
	MON=$(xrandr -q | grep " connected" | cut -f1 -d ' ')
	# find current xrandr brightness value
	if [ -f /tmp/BrNew.txt ]; then
		XR=`cat /tmp/BrNew.txt`
	else
		XR=100
		echo $XR >/tmp/BrNew.txt
	fi
	xrandr --output $MON --brightness $(awk "BEGIN {print $XR/100}")
	BrCur=`awk "BEGIN {print $XR}"` # calculate, so e.g. 0.5 gets 50
	BrMax="100"
	BrMin="10"
	yad --undecorated --on-top --geometry=200x70-30-30 --text=" INTEL2   BRIGHTNESS   CONTROL " --scale --value $BrCur --print-partial --min-value $MINBR --max-value $MAXBR --button="Done":1 | while read BrNew; do
	# division using awk, so xrandr value gets e.g. 0.5 rather than 50
	xrandr --output $MON --brightness $(awk "BEGIN {print $BrNew/100}")
	echo $BrNew >/tmp/BrNew.txt
	done 
fi


